public inbox for gentoo-commits@lists.gentoo.org
 help / color / mirror / Atom feed
From: "Sam James" <sam@gentoo.org>
To: gentoo-commits@lists.gentoo.org
Subject: [gentoo-commits] repo/gentoo:master commit in: sys-libs/musl/, sys-libs/musl/files/
Date: Sun, 20 Feb 2022 00:31:35 +0000 (UTC)	[thread overview]
Message-ID: <1645316986.b02003640228503cb93d5c371bef1f55c555429f.sam@gentoo> (raw)

commit:     b02003640228503cb93d5c371bef1f55c555429f
Author:     Esteve Varela Colominas <esteve.varela <AT> gmail <DOT> com>
AuthorDate: Sat Feb 12 15:34:33 2022 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Sun Feb 20 00:29:46 2022 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=b0200364

sys-libs/musl: Support Gentoo prefix

Added necessary framework to get this libc to run properly under a prefix.

Closes: https://bugs.gentoo.org/833192
Signed-off-by: Esteve Varela Colominas <esteve.varela <AT> gmail.com>
Closes: https://github.com/gentoo/gentoo/pull/24169
Signed-off-by: Sam James <sam <AT> gentoo.org>

 sys-libs/musl/files/ldconfig.in-r3                 | 160 +++++++++++++++++++++
 .../{musl-9999.ebuild => musl-1.2.2-r8.ebuild}     |  44 +++---
 sys-libs/musl/musl-9999.ebuild                     |  44 +++---
 3 files changed, 200 insertions(+), 48 deletions(-)

diff --git a/sys-libs/musl/files/ldconfig.in-r3 b/sys-libs/musl/files/ldconfig.in-r3
new file mode 100644
index 000000000000..60f6cc9e1130
--- /dev/null
+++ b/sys-libs/musl/files/ldconfig.in-r3
@@ -0,0 +1,160 @@
+#!/bin/bash -e
+# Copyright 1999-2022 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+ROOT="/"
+EPREFIX="@GENTOO_PORTAGE_EPREFIX@"
+LDSO_CONF_FILE="/etc/ld.so.conf"
+
+VERBOSE=0
+
+UPDATE_LINKS=1
+
+get_options() {
+	LDSO_CONF=""
+	while getopts "vnNXf:C:r:p" opt "$@"; do
+		case $opt in
+		v)
+			echo "ldconfig for musl in Gentoo"
+			VERBOSE=1
+			;;
+		r)
+			ROOT=${OPTARG}
+			;;
+		f)
+			LDSO_CONF=${OPTARG}
+			;;
+		X)
+			UPDATE_LINKS=0
+			;;
+		\?)
+			echo "Invalid option: -${opt}" >&2
+			exit 1
+			;;
+		n|N|C|p)
+			echo "Unimplemented option: -${opt}" >&2
+			exit 1
+			;;
+		esac
+	done
+	if [[ -z ${LDSO_CONF} ]]; then
+		LDSO_CONF=${ROOT}${EPREFIX}${LDSO_CONF_FILE}
+	fi
+
+	if [[ ${UPDATE_LINKS} == 1 ]]; then
+		echo "Updating links is not implemented."
+	fi
+}
+
+
+repeated() {
+	local l=${1}
+	local drs="${@:2}"
+	for m in ${drs}; do
+		[[ ${m} == ${l} ]] && return 0
+	done
+	return 1
+}
+
+expand() {
+	# We are assuming the ld.so.conf's 'include' is not recursive
+	local f line l
+	local glob="${LDSO_CONF_DIR}/${1}"
+	local drs="${@:2} "
+
+	for f in ${glob}; do
+		[[ ! -f ${f} ]] && continue
+		while read line; do
+			line=${line%%#*}
+			line=${line//:/ }
+			line=${line//,/ }
+			for l in ${line}; do
+				# We must add this whether or not the directory exists
+				repeated ${l} ${drs} && continue
+				drs+=" ${l} "
+			done
+		done < ${f}
+	done
+
+	echo ${drs}
+}
+
+read_ldso_conf() {
+	local drs=" "
+
+	while read line; do
+		# Sanitize the line - see ldconfig(8) for delimiters
+		# Note: bash read turns tabs into spaces and read already
+		# delimits on newlines with the default $IFS
+		line=${line%%#*}   # Remove comments
+		line=${line//:/ }  # Change colon delimiter to space
+		line=${line//,/ }  # Change comma delimiter to space
+
+		next=0
+		for l in ${line}; do
+			if [[ ${next} == 1 ]]; then
+				next=0
+				drs=$(expand ${l} ${drs})
+			elif [[ ${l} == "include" ]]; then
+				next=1
+			else
+				# glibc's ldconfig silently skips non directories
+				if [[ -d ${l} ]]; then
+					repeated ${l} ${drs} && continue
+					drs+=" ${l} "
+				fi
+			fi
+		done
+	done < ${1}
+
+	echo ${drs}
+}
+
+sanitize() {
+	local drs=$@
+
+	repeated "${EPREFIX}/lib" ${drs} || drs="${EPREFIX}/lib ${drs}"
+	repeated "${EPREFIX}/usr/lib" ${drs} || drs="${EPREFIX}/usr/lib ${drs}"
+
+	echo ${drs}
+}
+
+changed() {
+	[[ -f ${ETC_LDSO_PATH} ]] || return 0
+	local current=$(<${ETC_LDSO_PATH})
+	current=${current//$'\n'/ }
+	[[ ${current} != ${drs} ]] || return 1
+}
+
+get_options "$@"
+
+if [[ ! -e ${LDSO_CONF} ]]; then
+        echo "${LDSO_CONF} not found" >&2
+        exit 1
+fi
+
+LDSO_CONF_DIR=$(dirname ${LDSO_CONF})
+
+drs=$(read_ldso_conf "${LDSO_CONF}")
+drs=$(sanitize ${drs})
+
+ARCH=@@ARCH@@
+LDSO_PATH="${ROOT}${EPREFIX}/lib/ld-musl-${ARCH}.so.1"
+if [[ ! -e ${LDSO_PATH} ]]; then
+	echo "${LDSO_PATH} not found" >&2
+	exit 1
+fi
+
+LDSO_ARCH=$(basename ${LDSO_PATH})
+LDSO_NAME=${LDSO_ARCH%.so.1}
+ETC_LDSO_PATH="${ROOT}${EPREFIX}/etc/${LDSO_NAME}.path"
+
+changed || exit 0
+X=$(mktemp -p /tmp ${LDSO_NAME}.XXXXXX)
+for d in ${drs}; do
+	echo ${d} >> ${X}
+done
+chmod 644 ${X}
+# busybox doesn't support mz -Z
+cp ${X} ${ETC_LDSO_PATH}
+rm ${X}

diff --git a/sys-libs/musl/musl-9999.ebuild b/sys-libs/musl/musl-1.2.2-r8.ebuild
similarity index 76%
copy from sys-libs/musl/musl-9999.ebuild
copy to sys-libs/musl/musl-1.2.2-r8.ebuild
index 6a5e2688dd5a..52960e95a004 100644
--- a/sys-libs/musl/musl-9999.ebuild
+++ b/sys-libs/musl/musl-1.2.2-r8.ebuild
@@ -1,9 +1,9 @@
-# Copyright 1999-2021 Gentoo Authors
+# Copyright 1999-2022 Gentoo Authors
 # Distributed under the terms of the GNU General Public License v2
 
 EAPI=7
 
-inherit eapi8-dosym flag-o-matic toolchain-funcs
+inherit eapi8-dosym flag-o-matic toolchain-funcs prefix
 if [[ ${PV} == "9999" ]] ; then
 	EGIT_REPO_URI="git://git.musl-libc.org/musl"
 	inherit git-r3
@@ -76,11 +76,11 @@ src_configure() {
 	just_headers && export CC=true
 
 	local sysroot
-	is_crosscompile && sysroot="${EPREFIX}"/usr/${CTARGET}
+	is_crosscompile && sysroot=/usr/${CTARGET}
 	./configure \
 		--target=${CTARGET} \
-		--prefix=${sysroot}/usr \
-		--syslibdir=${sysroot}/lib \
+		--prefix=${EPREFIX}${sysroot}/usr \
+		--syslibdir=${EPREFIX}${sysroot}/lib \
 		--disable-gcc-wrapper || die
 }
 
@@ -111,8 +111,8 @@ src_install() {
 	# musl provides ldd via a sym link to its ld.so
 	local sysroot
 	is_crosscompile && sysroot=/usr/${CTARGET}
-	local ldso=$(basename "${D}"${sysroot}/lib/ld-musl-*)
-	dosym ${sysroot}/lib/${ldso} ${sysroot}/usr/bin/ldd
+	local ldso=$(basename "${ED}"${sysroot}/lib/ld-musl-*)
+	dosym ${EPREFIX}${sysroot}/lib/${ldso} ${sysroot}/usr/bin/ldd
 
 	if [[ ${CATEGORY} != cross-* ]] ; then
 		# Fish out of config:
@@ -121,24 +121,20 @@ src_install() {
 		# and print $(ARCH)$(SUBARCH).
 		local arch=$(awk '{ k[$1] = $3 } END { printf("%s%s", k["ARCH"], k["SUBARCH"]); }' config.mak)
 
-		if [[ ! -e "${ED}"/lib/ld-musl-${arch}.so.1 ]] ; then
-			# During cross (using crossdev), when emerging sys-libs/musl,
-			# if /usr/lib/libc.so.1 doesn't exist on the system, installation
-			# would fail.
-			#
-			# The musl build system seems to create a symlink:
-			# ${D}/lib/ld-musl-${arch}.so.1 -> /usr/lib/libc.so.1 (absolute)
-			# During cross, there's no guarantee that the host is using musl
-			# so that file may not exist. Use a relative symlink within ${D}
-			# instead.
-			dosym8 -r /usr/lib/libc.so /lib/ld-musl-${arch}.so.1
-
-			# If it's still a dead symlnk, OK, we really do need to abort.
-			[[ -e "${ED}"/lib/ld-musl-${arch}.so.1 ]] || die
-		fi
-
-		cp "${FILESDIR}"/ldconfig.in-r1 "${T}"/ldconfig.in || die
+		# The musl build system seems to create a symlink:
+		# ${D}/lib/ld-musl-${arch}.so.1 -> /usr/lib/libc.so.1 (absolute)
+		# During cross or within prefix, there's no guarantee that the host is
+		# using musl so that file may not exist. Use a relative symlink within
+		# ${D} instead.
+		rm -f "${ED}"/lib/ld-musl-${arch}.so.1 || die
+		dosym8 -r /usr/lib/libc.so /lib/ld-musl-${arch}.so.1
+
+		# If it's still a dead symlnk, OK, we really do need to abort.
+		[[ -e "${ED}"/lib/ld-musl-${arch}.so.1 ]] || die
+
+		cp "${FILESDIR}"/ldconfig.in-r3 "${T}"/ldconfig.in || die
 		sed -e "s|@@ARCH@@|${arch}|" "${T}"/ldconfig.in > "${T}"/ldconfig || die
+		eprefixify "${T}"/ldconfig
 		into /
 		dosbin "${T}"/ldconfig
 		into /usr

diff --git a/sys-libs/musl/musl-9999.ebuild b/sys-libs/musl/musl-9999.ebuild
index 6a5e2688dd5a..52960e95a004 100644
--- a/sys-libs/musl/musl-9999.ebuild
+++ b/sys-libs/musl/musl-9999.ebuild
@@ -1,9 +1,9 @@
-# Copyright 1999-2021 Gentoo Authors
+# Copyright 1999-2022 Gentoo Authors
 # Distributed under the terms of the GNU General Public License v2
 
 EAPI=7
 
-inherit eapi8-dosym flag-o-matic toolchain-funcs
+inherit eapi8-dosym flag-o-matic toolchain-funcs prefix
 if [[ ${PV} == "9999" ]] ; then
 	EGIT_REPO_URI="git://git.musl-libc.org/musl"
 	inherit git-r3
@@ -76,11 +76,11 @@ src_configure() {
 	just_headers && export CC=true
 
 	local sysroot
-	is_crosscompile && sysroot="${EPREFIX}"/usr/${CTARGET}
+	is_crosscompile && sysroot=/usr/${CTARGET}
 	./configure \
 		--target=${CTARGET} \
-		--prefix=${sysroot}/usr \
-		--syslibdir=${sysroot}/lib \
+		--prefix=${EPREFIX}${sysroot}/usr \
+		--syslibdir=${EPREFIX}${sysroot}/lib \
 		--disable-gcc-wrapper || die
 }
 
@@ -111,8 +111,8 @@ src_install() {
 	# musl provides ldd via a sym link to its ld.so
 	local sysroot
 	is_crosscompile && sysroot=/usr/${CTARGET}
-	local ldso=$(basename "${D}"${sysroot}/lib/ld-musl-*)
-	dosym ${sysroot}/lib/${ldso} ${sysroot}/usr/bin/ldd
+	local ldso=$(basename "${ED}"${sysroot}/lib/ld-musl-*)
+	dosym ${EPREFIX}${sysroot}/lib/${ldso} ${sysroot}/usr/bin/ldd
 
 	if [[ ${CATEGORY} != cross-* ]] ; then
 		# Fish out of config:
@@ -121,24 +121,20 @@ src_install() {
 		# and print $(ARCH)$(SUBARCH).
 		local arch=$(awk '{ k[$1] = $3 } END { printf("%s%s", k["ARCH"], k["SUBARCH"]); }' config.mak)
 
-		if [[ ! -e "${ED}"/lib/ld-musl-${arch}.so.1 ]] ; then
-			# During cross (using crossdev), when emerging sys-libs/musl,
-			# if /usr/lib/libc.so.1 doesn't exist on the system, installation
-			# would fail.
-			#
-			# The musl build system seems to create a symlink:
-			# ${D}/lib/ld-musl-${arch}.so.1 -> /usr/lib/libc.so.1 (absolute)
-			# During cross, there's no guarantee that the host is using musl
-			# so that file may not exist. Use a relative symlink within ${D}
-			# instead.
-			dosym8 -r /usr/lib/libc.so /lib/ld-musl-${arch}.so.1
-
-			# If it's still a dead symlnk, OK, we really do need to abort.
-			[[ -e "${ED}"/lib/ld-musl-${arch}.so.1 ]] || die
-		fi
-
-		cp "${FILESDIR}"/ldconfig.in-r1 "${T}"/ldconfig.in || die
+		# The musl build system seems to create a symlink:
+		# ${D}/lib/ld-musl-${arch}.so.1 -> /usr/lib/libc.so.1 (absolute)
+		# During cross or within prefix, there's no guarantee that the host is
+		# using musl so that file may not exist. Use a relative symlink within
+		# ${D} instead.
+		rm -f "${ED}"/lib/ld-musl-${arch}.so.1 || die
+		dosym8 -r /usr/lib/libc.so /lib/ld-musl-${arch}.so.1
+
+		# If it's still a dead symlnk, OK, we really do need to abort.
+		[[ -e "${ED}"/lib/ld-musl-${arch}.so.1 ]] || die
+
+		cp "${FILESDIR}"/ldconfig.in-r3 "${T}"/ldconfig.in || die
 		sed -e "s|@@ARCH@@|${arch}|" "${T}"/ldconfig.in > "${T}"/ldconfig || die
+		eprefixify "${T}"/ldconfig
 		into /
 		dosbin "${T}"/ldconfig
 		into /usr


             reply	other threads:[~2022-02-20  0:31 UTC|newest]

Thread overview: 11+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2022-02-20  0:31 Sam James [this message]
  -- strict thread matches above, loose matches on Subject: below --
2025-02-13 17:43 [gentoo-commits] repo/gentoo:master commit in: sys-libs/musl/, sys-libs/musl/files/ Petr Vaněk
2024-05-20  8:16 Sam James
2023-11-09  0:57 Sam James
2022-07-26  4:15 Sam James
2022-04-17 18:32 Sam James
2021-11-22 12:18 Sam James
2021-11-19  3:03 Sam James
2021-02-14 16:50 Jory Pratt
2018-10-02 23:43 Anthony G. Basile
2016-10-18 23:53 Anthony G. Basile

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1645316986.b02003640228503cb93d5c371bef1f55c555429f.sam@gentoo \
    --to=sam@gentoo.org \
    --cc=gentoo-commits@lists.gentoo.org \
    --cc=gentoo-dev@lists.gentoo.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox